--Ϣ
QR_Frame.InfoFrame = CreateFrame( "Button", "QuestRepeatInfoFrame", UIParent, "SecureActionButtonTemplate,SecureHandlerShowHideTemplate" );
local infoFrame = QR_Frame.InfoFrame;
tinsert(UISpecialFrames, "QuestRepeatInfoFrame");
infoFrame:Hide();
local closeBtn = CreateFrame( "Button", nil, QuestRepeatInfoFrame, "UIPanelCloseButton" );
local calculatorBtn = CreateFrame( "Button", "calculatorButton", QuestRepeatInfoFrame, "UIPanelButtonTemplate" );

-- Ϣ
	infoFrame:SetWidth(180);
	infoFrame:SetHeight(150);
	infoFrame:ClearAllPoints();
	infoFrame:SetPoint("TOPRIGHT", QuestFrame, 155, -20);
	infoFrame:EnableKeyboard(true);
	infoFrame:SetClampedToScreen( true );
	infoFrame:SetFrameStrata( "HIGH" );
	infoFrame:SetNormalTexture( "Interface\\AchievementFrame\\UI-Achievement-Parchment-Horizontal" );
	local Background = infoFrame:GetNormalTexture();
	Background:SetDrawLayer( "BACKGROUND" );
	Background:ClearAllPoints();
	Background:SetPoint( "BOTTOMLEFT", 3, 3 );
	Background:SetPoint( "TOPRIGHT", -3, -3 );
	Background:SetTexCoord( 0, 1, 0, 0.25 );

	local TitleBackground = infoFrame:CreateTexture( nil, "BORDER" );
	TitleBackground:SetTexture( "Interface\\AchievementFrame\\UI-Achievement-Title" );
	TitleBackground:SetPoint( "TOPRIGHT", -5, -5 );
	TitleBackground:SetPoint( "LEFT", 5, 0 );
	TitleBackground:SetHeight( 18 );
	TitleBackground:SetTexCoord( 0, 0.9765625, 0, 0.3125 );
	TitleBackground:SetAlpha( 0.8 );

	--
	local AddonTitle = infoFrame:CreateFontString( nil, "OVERLAY", "GameFontBlack" );
	AddonTitle:SetPoint( "LEFT", TitleBackground );
	AddonTitle:SetPoint( "RIGHT", TitleBackground );
	AddonTitle:SetText( ADDON_TITLE );

	--
	infoFrame.questTitle = infoFrame:CreateFontString( nil, "OVERLAY", "GameFontNormal" );
	local questTitle = infoFrame.questTitle;
	questTitle:SetPoint( "TOPLEFT", TitleBackground, "TOPLEFT", 5, -20 );
	questTitle:SetJustifyH("LEFT")
	questTitle:SetWidth(160);

	--ʾʣ´
	local questTimes = infoFrame:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );
	questTimes:SetPoint( "TOPLEFT", questTitle, "BOTTOMLEFT", 40, -4 );
	
	--ܻõ
	local rewardPoints = infoFrame:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );

	-- ǰܵ
	local CurPointsTitle = infoFrame:CreateFontString( nil, "OVERLAY", "GameFontNormal" );
	CurPointsTitle:SetPoint( "TOP", rewardPoints, "BOTTOM", 0, -4 );
	CurPointsTitle:SetPoint( "LEFT", questTitle );

	local honorPoints = infoFrame:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );
	honorPoints:SetPoint( "TOP", CurPointsTitle, "BOTTOM", 0, -4 );
	honorPoints:SetPoint( "LEFT", infoFrame, "LEFT", 70, 0);

	--
	local repTitle = infoFrame:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );
	repTitle:SetPoint( "TOP", CurPointsTitle, "BOTTOM", 0, -4 );
	repTitle:SetPoint( "LEFT", infoFrame );
	repTitle:SetPoint( "RIGHT", infoFrame );

	local repBar = CreateFrame( "StatusBar", "QuestInfoRepBar", QuestRepeatInfoFrame );
	repBar:SetMinMaxValues(0, 100);
	repBar:SetWidth(160);
	repBar:SetHeight(18);
	repBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
	repBar:SetStatusBarColor(0, 1, 0, 0.8);--R G B alpha
	repBar:SetBackdropBorderColor(0, 0, 1, 1);
	repBar:SetFrameLevel(2);
	repBar:SetPoint( "TOP", repTitle, "BOTTOM", 0, -5 );
	repBar:SetPoint( "LEFT", infoFrame, "LEFT", 10, 0 );

	local repPoints = repBar:CreateFontString( nil, "OVERLAY", "GameFontHighlight" );
	repPoints:SetPoint( "CENTER", repBar, "CENTER", 0, 2);

	local repBarBack = CreateFrame( "StatusBar", "QuestInfoRepBarBack", QuestRepeatInfoFrame );
	repBarBack:SetMinMaxValues(0, 100);
	repBarBack:SetWidth(160);
	repBarBack:SetHeight(18);
	repBarBack:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
	repBarBack:SetStatusBarColor(0, 0, 0, 0.4);--R G B alpha
	repBarBack:SetFrameLevel(1);
	repBarBack:SetPoint( "CENTER", repBar, "CENTER");

	--ͼ
	local totalHonorIcon = infoFrame:CreateTexture(nil);
	local factionGroup = UnitFactionGroup("player");
	if factionGroup == "Alliance" then
		totalHonorIcon:SetTexture("Interface\\PVPFrame\\PVP-Currency-Alliance");
	else
		totalHonorIcon:SetTexture("Interface\\PVPFrame\\PVP-Currency-Horde");
	end
	totalHonorIcon:SetHeight(22);
	totalHonorIcon:SetWidth(22);
	totalHonorIcon:SetPoint("LEFT", rewardPoints, "RIGHT", 2, 0);

	local curHonorIcon = infoFrame:CreateTexture(nil);
	if factionGroup == "Alliance" then
		curHonorIcon:SetTexture("Interface\\PVPFrame\\PVP-Currency-Alliance");
	else
		curHonorIcon:SetTexture("Interface\\PVPFrame\\PVP-Currency-Horde");
	end
	curHonorIcon:SetHeight(22);
	curHonorIcon:SetWidth(22);
	curHonorIcon:SetPoint("LEFT", honorPoints, "RIGHT", 2, 0);
	--߿
	infoFrame:SetBackdrop( {
		tile = true; edgeSize = 16;
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border";
	} );

	--رհť
	closeBtn:SetPoint( "TOPRIGHT" );
	closeBtn:SetWidth( 32 );
	closeBtn:SetHeight( 32 );
	closeBtn:SetScale( 0.8 );
	closeBtn:SetHitRectInsets( 8, 8, 8, 8 );

	--ť
	calculatorBtn:SetPoint( "BOTTOM", QuestRepeatInfoFrame, 0, 8 );
	calculatorBtn:SetWidth( 90 );
	calculatorBtn:SetHeight( 22 );
	calculatorBtn:SetText(CALCULATOR);

	--߿򷢹
	local Texture = infoFrame:CreateTexture( nil, "OVERLAY" );
	Texture:SetPoint( "CENTER", infoFrame );
	Texture:SetWidth( 400 / 300 * infoFrame:GetWidth() );
	Texture:SetHeight( 171 / 70 * infoFrame:GetHeight() );
	Texture:SetTexture( "Interface\\AchievementFrame\\UI-Achievement-Alert-Glow" );
	Texture:SetBlendMode( "ADD" );
	Texture:SetTexCoord( 0, 0.78125, 0, 0.66796875 );
	Texture:SetAlpha( 0 );
	infoFrame.Glow = Texture:CreateAnimationGroup();
	local FadeIn = infoFrame.Glow:CreateAnimation( "Alpha" );
	FadeIn:SetChange( 1.0 );
	FadeIn:SetDuration( 0.2 );
	local FadeOut = infoFrame.Glow:CreateAnimation( "Alpha" );
	FadeOut:SetOrder( 2 );
	FadeOut:SetChange( -1.0 );
	FadeOut:SetDuration( 0.5 );

	--
	Texture = infoFrame:CreateTexture( nil, "ARTWORK" );
	Texture:SetPoint( "TOPLEFT", infoFrame, 0, 8 );
	Texture:SetWidth( 67 / 300 * infoFrame:GetWidth() );
	Texture:SetHeight( 1.28 * infoFrame:GetHeight() );
	Texture:SetTexture( "Interface\\AchievementFrame\\UI-Achievement-Alert-Glow" );
	Texture:SetBlendMode( "ADD" );
	Texture:SetTexCoord( 0.78125, 0.912109375, 0, 0.28125 );
	Texture:SetAlpha( 0 );
	infoFrame.Shine = Texture:CreateAnimationGroup();
	local Show = infoFrame.Shine:CreateAnimation( "Alpha" );
	Show:SetStartDelay( 0.3 );
	Show:SetChange( 1.0 );
	Show:SetDuration( 1e-5 ); 
	local Slide = infoFrame.Shine:CreateAnimation( "Translation" );
	Slide:SetOrder( 2 );
	Slide:SetOffset( infoFrame:GetWidth() - Texture:GetWidth() + 8, 0 );
	Slide:SetDuration( 0.4 );
	local FadeOut = infoFrame.Shine:CreateAnimation( "Alpha" );
	FadeOut:SetOrder( 2 );
	FadeOut:SetStartDelay( 0.2 );
	FadeOut:SetChange( -1.0 );
	FadeOut:SetDuration( 0.2 );

function infoFrame:OnHide()
	initialize();
	QuestRepeatNormalMode( true );
	QR_Frame.CalHonorFrame:Hide();
	QR_Frame.CalRepFrame:Hide();
end

function calculatorBtn:OnClick()
	if (g_Cal_Mode == "Honor") then
		QR_Frame.CalHonorFrame:Show();
	elseif (g_Cal_Mode == "Reputation") then
		QR_Frame.CalRepFrame:Show();	
	end
end

function infoFrame.Update( questName )
	infoFrame:Show();
	if(g_ShineFlag)then
		infoFrame.Shine:Play();
		infoFrame.Glow:Play();
		g_ShineFlag = false;
	end
	questTitle:SetText( questName );
	questTimes:SetText( LEFT.."  "..g_MaxValue.."  "..TIMES );--ʾʣ
	local height = 0;
	if (questTitle:GetStringHeight() > 18) then
		height = 15;
	end
	if (g_Cal_Mode == "Honor") then
		infoFrame:SetHeight(150 + height);
		rewardPoints:ClearAllPoints();
		rewardPoints:SetPoint( "TOPLEFT", questTimes, "BOTTOMLEFT", 0, -4 );
		rewardPoints:SetText(TOTAL.." "..g_HonorReward * g_MaxValue);
		CurPointsTitle:SetText(YOUR_HONOR_IS);
		g_HonorPoints = GetHonorCurrency();
		honorPoints:SetText(g_HonorPoints);
		honorPoints:Show();
		curHonorIcon:Show();
		totalHonorIcon:Show();
		repTitle:Hide();
		repPoints:Hide();
		repBar:Hide();
		repBarBack:Hide();
		calculatorBtn:Enable();
	elseif (g_Cal_Mode == "Reputation") then
		infoFrame:SetHeight(170 + height);
		rewardPoints:ClearAllPoints();
		rewardPoints:SetPoint( "TOP", questTimes, "BOTTOM", 0, -4 );
		rewardPoints:SetPoint( "LEFT", infoFrame);
		rewardPoints:SetPoint( "RIGHT", infoFrame);
		rewardPoints:SetText(TOTAL_REP.." "..(g_RepStatus.repReward * g_MaxValue).." "..REP_POINT);
		CurPointsTitle:SetText(YOUR_REP_IS);
		if (g_RepStatus.name ~= "") then
			repTitle:SetText(g_RepStatus.name);
		else
			repTitle:SetText(Rep_Reminding);
		end
		repPoints:SetText(g_RepStatus.standingText.."("..
				g_RepStatus.barValue-g_RepStatus.barMin.." /"..g_RepStatus.barMax-g_RepStatus.barMin..")");
		repBar:SetValue( ((g_RepStatus.barValue-g_RepStatus.barMin) 
				/ (g_RepStatus.barMax-g_RepStatus.barMin)) * 100 );
		honorPoints:Hide();
		totalHonorIcon:Hide();
		curHonorIcon:Hide();
		repBar:Show();
		repTitle:Show();
		repPoints:Show();
		repBarBack:Show();
		if (g_RepStatus.repReward == 0) then
			calculatorBtn:Disable();
		else
			calculatorBtn:Enable();
		end
	end
end

infoFrame:SetScript("OnHide", infoFrame.OnHide);
calculatorBtn:SetScript("OnClick", calculatorBtn.OnClick)
