QR_Frame = {};
local repInfo = {
	npcName = "",
	questName = "",
	repReward = 0,
	factionName = "",
	zoneName = "",	
	questItems={},
};
g_QuestItems = {
	name = "",
	texture = "",
	reqNum = 0,
	maxStack = 0,
	hadSlot = 0,
	hadNum = 0};
local _, playerRace = UnitRace("player");
--˵: ʼֵ
function initialize()
	g_MaxValue = 1;
	g_Iterator = 0;
	g_QuestName = "";
	g_HonorReward = 0;
	g_HonorPoints = 0;
	g_ShineFlag = true;
	g_Cal_Mode = "";
	g_RepRewardText = "";
	g_RepStatus = {
		name = "",
		standingID = 1,
		standingText = "",
		barMin = 0,
		barMax = 0,
		barValue = 0,
		repReward = 0,};
end

--غʼעἸ¼
function QuestRepeat_OnLoad()
	initialize();
	this:RegisterEvent("GOSSIP_CLOSED");
	this:RegisterEvent("GOSSIP_SHOW");
	this:RegisterEvent("QUEST_COMPLETE");
	this:RegisterEvent("QUEST_PROGRESS");
	this:RegisterEvent("ADDON_LOADED");
end 

--¼
function QuestRepeat_OnEvent()
	if (event == "ADDON_LOADED") then
		if (QR_RepDB == nil) then
			QR_RepDB = {};
		end
		if QR_VerControl ~= "2.3.3" then
			QR_RepDB = {};
			QR_VerControl = "2.3.3";
			DEFAULT_CHAT_FRAME:AddMessage("|cffa335ee<"..ADDON_TITLE.." v"..QR_VerControl..">|r"..Data_Clear);
		end
	elseif (event == "GOSSIP_CLOSED") then
		if (g_Iterator < 1) then
			initialize();
		end
	elseif (event == "QUEST_PROGRESS") then
		if (IsQuestCompletable() and g_Iterator == 0) then
			n = GetNumQuestItems();
			i = 0;
			if (n ~= nil) then	
				if (n ~= 0) then
					g_MaxValue = 9999;
					g_QuestItems = {
						name = "",
						texture = "",
						reqNum = 0,
						maxStack = 0,
						hadSlot = 0,
						hadNum = 0};
					while i < n do
						i = i + 1;
						local itemName, itemTexture, numItems = GetQuestItemInfo("required",i);
						tinsert(g_QuestItems, {name=itemName, texture = itemTexture, reqNum = numItems});
						local hadNum = Item_Check(g_QuestItems[i].name)
						local value = floor(hadNum/g_QuestItems[i].reqNum)
						if (value < g_MaxValue) then
							g_MaxValue = value;
						end
						_, _, _, _, _, _, _, g_QuestItems[i].maxStack = GetItemInfo(itemName);
						g_QuestItems[i].hadSlot = value;
						g_QuestItems[i].hadNum = hadNum;
					end
				end
			end
		elseif(g_Iterator > 0) then
			QuestProgressCompleteButton_OnClick();		
		end
	elseif (event == "QUEST_DETAIL") then
		if (g_Iterator > 0 ) then
			QuestDetailAcceptButton_OnClick();
		end
	elseif (event == "QUEST_COMPLETE") then
		this:RegisterEvent("QUEST_FINISHED");
		SetCalMode();
		QuestRepeatInputBox:SetNumber(g_MaxValue);
		if (g_MaxValue > 1) then
			this:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");
			QuestRepeatNormalMode( false );
			QR_Frame.InfoFrame.Update(GetTitleText());
			if(GetTitleText() == g_QuestName) then
				QuestRepeatAllButton_OnClick();			
			end
		else
			g_Iterator = 0;
			QuestRepeatNormalMode( true );
		end
	elseif (event == "GOSSIP_SHOW") then
		if (g_Iterator > 0) then
			if GetGossipAvailableQuests() then
				i = 1;
				for index, value in pairs({GetGossipAvailableQuests()}) do
					if( mod(index-1, 3) == 0 ) then							
						if (value == g_QuestName) then
							SelectGossipAvailableQuest(i);
							break;
						end
					i = i + 1;
					end
				end
			end
			if GetGossipActiveQuests() then
				i = 1;
				for index, value in pairs({GetGossipActiveQuests()}) do
					if( mod(index-1, 3) == 0 ) then
						if (value == g_QuestName) then
							SelectGossipActiveQuest(i);
							break;
						end
					i = i + 1;
					end
				end				
			end
		end
	elseif (event == "QUEST_FINISHED") then
		if(g_Iterator == 0)then
			QR_Frame.InfoFrame:Hide();
		end
		if (QuestFrame:IsShown() == nil) then
			QR_Frame.CalRepFrame:Hide();
			QR_Frame.CalHonorFrame:Hide();
		end
		this:UnregisterEvent("QUEST_FINISHED");
	elseif (event == "CHAT_MSG_COMBAT_FACTION_CHANGE") then
		g_RepRewardText = arg1;
		g_RepRewardText = string.gsub(g_RepRewardText, RepInfo_Head, "");
                g_RepRewardText = string.gsub(g_RepRewardText, RepInfo_Middle, "");
		g_RepRewardText = string.gsub(g_RepRewardText, RepInfo_End, "");
		local numFactions = GetNumFactions();
		local name, standingID; 
		for i=1, numFactions do
			name = GetFactionInfo(i);
			if string.find(g_RepRewardText,name) then
                		g_RepStatus.name, _, g_RepStatus.standingID, g_RepStatus.barMin,
				g_RepStatus.barMax, g_RepStatus.barValue = GetFactionInfo(i);
				g_RepStatus.standingText = GetText("FACTION_STANDING_LABEL"..g_RepStatus.standingID, UnitSex("player"));
				repInfo.factionName = g_RepStatus.name;
			end
		end                                                
		g_RepRewardText = string.gsub(g_RepRewardText, g_RepStatus.name, "");
		g_RepStatus.repReward = tonumber(g_RepRewardText) or 0;
		if (g_RepStatus.repReward ~= 0) then	
			if playerRace == "Human" then
				if mod(g_RepStatus.repReward, 11) ~= 0 then
					if mod(g_RepStatus.repReward * 2 + 1, 5) == 0 then
						repInfo.repReward = (g_RepStatus.repReward * 2 + 1)/2.2;
					elseif mod(g_RepStatus.repReward * 2 - 1, 5) == 0 then
						repInfo.repReward = (g_RepStatus.repReward * 2 - 1)/2.2;
					end
				else
					repInfo.repReward = g_RepStatus.repReward/1.1;
				end
			else
				repInfo.repReward = g_RepStatus.repReward;
			end
			for index = 1, table.maxn(g_QuestItems) do
				table.insert(repInfo.questItems,
					{name = g_QuestItems[index].name,
					texture = g_QuestItems[index].texture,
					reqNum = g_QuestItems[index].reqNum,
					maxStack = g_QuestItems[index].maxStack});
			end
			table.sort(repInfo);
			if (table.getn(QR_RepDB) == 0) then
				table.insert(QR_RepDB, repInfo);
			end
			local isHad = false;
			for i, item in pairs(QR_RepDB) do
				if (item.npcName == repInfo.npcName) then
					if (item.questName == repInfo.questName) then
						isHad = true;
					end
				end
			end
			if (isHad == false) then
				table.insert(QR_RepDB, repInfo);
			end
		end
		if (this:IsShown() == 1) then
			QR_Frame.InfoFrame.Update(QR_Frame.InfoFrame.questTitle:GetText());
		end
		this:UnregisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");
	end
end

function SetCalMode()
	g_HonorReward = GetRewardHonor();
	g_HonorPoints = GetHonorCurrency();
	repInfo = {
		npcName = "",
		questName = "",
		repReward = 0,
		factionName = "",
		zoneName = "",	
		questItems={},
	};
	if g_RepStatus.repReward == 0 then
		ExpandAllFactionHeaders();
		for i, item in pairs(QR_RepDB) do
			if (item.npcName == GetUnitName("npc")) then
				if (item.questName == GetTitleText()) then
					for i=1, GetNumFactions() do
						name = GetFactionInfo(i);
						if (name == item.factionName) then
             				   		g_RepStatus.name, _, g_RepStatus.standingID, g_RepStatus.barMin,
							g_RepStatus.barMax, g_RepStatus.barValue = GetFactionInfo(i);
							g_RepStatus.standingText = 
								GetText("FACTION_STANDING_LABEL"..g_RepStatus.standingID, UnitSex("player"));
						end
					end
					if playerRace == "Human" then
						g_RepStatus.repReward = item.repReward * 1.1;
					else
						g_RepStatus.repReward = item.repReward;
					end
				end
			end
		end
	end
	if (g_HonorReward ~= 0) then
		g_Cal_Mode = "Honor";
	else
		g_Cal_Mode = "Reputation";
	end
end

--㱳жƷ
function Item_Check(name)
	Count = 0;
    for bag = 4, 0, -1 do
        local size = GetContainerNumSlots(bag);
        if (size > 0) then
            -- for each slot in the bag
            for slot = 1, size do
                local texture, itemCount = GetContainerItemInfo(bag, slot);
                if (itemCount) then
		    local itemLink = GetContainerItemLink(bag,slot)
		    local _, _, itemCode = strfind(itemLink, "(%d+):")
		    local itemName, _, _, _, _, _ = GetItemInfo(itemCode)
 		    -- if the item has a name
	 	    if (itemName ~= "" and itemName ~= nil) then
                        if (itemName == name) then
                            Count = Count + itemCount;
                        end
                    end
                end
            end
        end
    end


	local scrollFrame = TokenFrameContainer;
	local offset = HybridScrollFrame_GetOffset(scrollFrame);
	local buttons = scrollFrame.buttons;
	local numButtons = #buttons;
	local itemName, itemCount;
	local index;
	for i=1, numButtons do
		index = offset+i;
		itemName, _, _, _, _, itemCount = GetCurrencyListInfo(index);
		if (itemName == name) then
                	Count = Count + itemCount;
            	end
	end
    return Count;
end

--ǷʹĬϵʽ
function QuestRepeatNormalMode( flag )
	if (flag) then
		QuestRepeat:Hide();
		QuestFrameCompleteQuestButton:Show();
	else
		QuestFrameCompleteQuestButton:Hide();
		QuestRepeat:Show();
	end
end

--ȫɡť
function QuestRepeatAllButton_OnClick()
	local inputNum = QuestRepeatInputBox:GetNumber();
	if (inputNum == 0)then
		inputNum = g_MaxValue;
	elseif (inputNum < g_MaxValue)then
		g_MaxValue = inputNum;
	end
	g_MaxValue = g_MaxValue - 1;
	g_QuestName = GetTitleText();
	g_Iterator = g_MaxValue;
	QuestRewardCompleteButton_OnClick();
	QR_Frame.InfoFrame.Update(g_QuestName);
	repInfo.questName = g_QuestName;
	repInfo.zoneName = GetZoneText();
	repInfo.npcName = GetUnitName("npc");
end

--һΡť
function QuestRepeatOnceButton_OnClick()
	g_MaxValue = g_MaxValue - 1;
	g_Iterator = 0;
	QuestRewardCompleteButton_OnClick();
	QR_Frame.InfoFrame.Update(GetTitleText());
	repInfo.questName = GetTitleText();
	repInfo.zoneName = GetZoneText();
	repInfo.npcName = GetUnitName("npc");
end

--ֵ'<'ť
function QuestRepeatDecrement_OnClick()
	if (QuestRepeatInputBox:GetNumber() > 1) then
		QuestRepeatInputBox:SetNumber(QuestRepeatInputBox:GetNumber() - 1);
	end
end

--ֵ'>'ť
function QuestRepeatIncrement_OnClick()
	if (QuestRepeatInputBox:GetNumber() < g_MaxValue) then
		QuestRepeatInputBox:SetNumber(QuestRepeatInputBox:GetNumber() + 1);
	end
end

--ֵֿĴԽ紦
function QuestRepeatInputBox_OnTextChanged()
	local num = this:GetNumber();
	if (num > g_MaxValue) then
		this:SetNumber(g_MaxValue);
	end
end

--Just use for develop testing
local function QuestRepeat_SlashCommand(msg, editbox)
	if msg == "Honor" then
		g_Cal_Mode = "Honor";
		g_HonorPoints = 12345;
		g_HonorReward = 314;
	elseif  msg == "Rep" then
		g_RepStatus.name, _, g_RepStatus.standingID, g_RepStatus.barMin,g_RepStatus.barMax, g_RepStatus.barValue = GetFactionInfo(3);
		g_RepStatus.standingText = GetText("FACTION_STANDING_LABEL"..g_RepStatus.standingID, UnitSex("player"));
		g_RepStatus.repReward = 250;
		g_Cal_Mode = "Reputation";
	elseif  msg == "Clear" then
		QR_RepDB = {};
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<"..ADDON_TITLE..">|r"..Data_Clear);
		return
	else
		return
	end
	g_QuestItems = {
		{["name"] = "Test Quest Item_1",
		["texture"] = "Interface\\ICONS\\Spell_Holy_ChampionsBond",
		["reqNum"] = 1,
		["maxStack"] = 10,
		["hadSlot"] = 1,
		["hadNum"] = 11},
		{["name"] = "Test Quest Item_Name_2",
		["texture"] = "Interface\\ICONS\\Spell_Holy_ChampionsBond",
		["reqNum"] = 10,
		["maxStack"] = 20,
		["hadSlot"] = 1,
		["hadNum"] = 22},
		{["name"] = "Test Quest Item_Wide_Name_3",
		["texture"] = "Interface\\ICONS\\Spell_Holy_ChampionsBond",
		["reqNum"] = 20,
		["maxStack"] = 20,
		["hadSlot"] = 3,
		["hadNum"] = 32},
		{["name"] = "Test Quest Item_Max_Width_Name_4",
		["texture"] = "Interface\\ICONS\\Spell_Holy_ChampionsBond",
		["reqNum"] = 120,
		["maxStack"] = 120,
		["hadSlot"] = 2,
		["hadNum"] = 241},
	};
	g_MaxValue = 3;
	g_QuestName = "Test Quest Name";
	g_ShineFlag = true;
	QR_Frame.InfoFrame.Update(g_QuestName);
end

SLASH_QUESTREPEAT1 = "/questrepeat";
SlashCmdList["QUESTREPEAT"] = QuestRepeat_SlashCommand;
